
// Tales of Phantasia MSU1 patch by Conn 
// this needs an expanded rom to 8MB
// Use xkas-plus v14+1 to compile this asm https://github.com/devinacker/xkas-plus/releases/tag/v14%2B1

//$7e0160: track number
//$7e0161: fade Flag
//$7e0162: fade current Volume
//$7e0163: flag play special Harvest/Twilight

arch snes.cpu
exhirom

//hardmute
//org $F3BBEC
//db $2f

org $C01FFB
JSL newTrack

org $C01F59
JSL fadeFlag

org $C0016e
JSL irq

org $C7FCCD
JSL mute

org $C43A7F
JSL twilightHarvest
NOP

//org $C6D277
org $c43a8a
JSL securityCheckHarvestTH

org $C4095A
JML pianoCheck


org $600100
newTrack:
STA $87
LDA $002002
cmp #$53 
bne end
LDA #$00
STA $7e0161
STA $002006
LDA $87
STA $7e0160
cmp #$00
BEQ end
cmp #$23
bne $03
jsr resumeMusic
cmp #$41
bne $03
jsr resumeMusic
STA $002004
LDA #$00
STA $002005
STA $7e0163
loop:
LDA $002000
AND #$40
BNE loop
LDA $002000
AND #$08
BNE end
LDA #$01
BRA $02
end:
LDA $87
Rep #$20
RTL

resumeMusic:
PHA
LDA #$04
STA $002007
PLA
RTS 

fadeFlag:
SEP #$20
STA $35
cmp #$29
beq play
cmp #$08
BEQ fadeDown
cmp #$18
BEQ fadeUp
cmp #$12
BEQ pause
cmp #$13
BEQ resume
RTL
play:
LDA $002000
AND #$08
BNE nopcm
PHX
LDA #$00
XBA
LDX #$0000
LDA $7e0160
TAX
LDA $600500,x
STA $002007
PLX
LDA #$ff
STA $002006
STA $7e0162 //fadeVolume
nopcm:
LDA #$29

RTL
fadeDown:
	waitLoop:
	LDA $7e0161
	cmp #$02
	beq waitLoop

LDA #$01
STA $7e0161
LDA #$08
RTL

fadeUp:
LDA $002000
AND #$08
BNE nopcm1
PHX
LDA #$00
XBA
LDX #$0000
LDA $7e0160
TAX
LDA $600500,x
STA $002007
PLX
LDA #$00
STA $002006
STA $7e0162 //fadeVolume
LDA #$02
STA $7e0161
nopcm1:
LDA #$18
RTL
pause:
LDA #$00
STA $002007
LDA #$12
RTL
resume:
LDA #$00
XBA
LDA $7e0160
PHX
LDX #$0000
TAX
LDA $600500,x
STA $002007
PLX
LDA #$13
RTL




irq:
LDA #$0000
TCD
SEP #$20
LDA $7e0163
BNE irq63
continueirq:
LDA $7e0161
beq endirq
cmp #$01
BNE $03 
jmp fadeDownSlow
cmp #$02
bne $03 
jmp fadeUpSlow
cmp #$03
BNE $03 
jmp fadeDownTH
cmp #$04
BNE $03
jmp fadeUpTH
endirq:
LDA #$00
STA $7e0161
RTL

irq63:
CMP #$03
BNE continueirq
LDA $7e0164
cmp #$03
BEQ continueirq
LDA $7e0162
cmp #$00
BNE continueirq
LDA $7e0161
cmp #$03
BEQ continueirq
LDA #$04
STA $7e0161
LDA #$00
STA $7e0163
bra continueirq




fadeDownSlow:
lda $7e0162
CMP #$00
BEQ endslow
dec
dec
cmp #$10
bcs $0a
endslow:
lda #$00
sta $7e0161//erase fade flag
sta $7e0160
sta $002006
sta $7e0162
LDA #$00
RTL

fadeUpSlow:
lda $7e0162
CMP #$ff    //final level?
BEQ endfull
inc
inc
cmp #$fb
bcc $08
endfull:
lda #$00
sta $7e0161 //erase fade flag
LDA #$FF
sta $002006
sta $7e0162
LDA #$00
RTL

fadeDownTH:
lda $7e0162
CMP #$00
BEQ endslow
dec
dec
dec
dec
dec
cmp #$11
bcs $06
endslow:
lda #$00
sta $7e0161//erase fade flag
sta $002006
sta $7e0162
LDA #$00
RTL

fadeUpTH:
lda $7e0162
CMP #$ff    //final level?
BEQ endfull
inc
inc
inc
inc
inc
cmp #$fa
bcc $08
endfull:
lda #$00
sta $7e0161 //erase fade flag
LDA #$FF
sta $002006
sta $7e0162
LDA #$00
RTL

mute:
LDA #$04
STA $002007
LDA #$00
sta $7e0161
sta $7e0160
sta $7e0162
STA $002006
JSL $C67089
RTL



twilightHarvest:
SEP #$20
PHA
LDA $002002
cmp #$53 
beq $03 
jmp endTH
LDA $7e0160 //in Euclid?
CMP #$2e
BEQ $04
cmp #$30
BNE endTH
PLA
PHA
CMP #$48
BCC $08
LDA #$00
STA $7e0164
bra endTH
LDA $7e0161 //currently fadeUp/Fade Down?
cmp #$03
BEQ endTH
LDA $7e0163
cmp #$03
BEQ playMSUTH
LDA $7e0163
cmp #$00
BNE endTH
LDA #$03
STA $7e0161
STA $7e0163
STA $7e0164
BRA endTH




playMSUTH:
// play Twilight or Harvest
LDA $7e0160
cmp #$2e
BNE $04
LDA #$4f //Twilight
BRA $02
LDA #$4E //Harvest
STA $7e0163
msuEuclid:
STA $002004
LDA #$00
STA $002005
STA $002006
loopTH:
LDA $002000
AND #$40
BNE loopTH
LDA $002000
AND #$08
BNE playSPCTH
LDA #$03
STA $002007
LDA #$00
STA 002006
STA $7e0162
LDA #$04
STA $7e0161


endTH:
PLA
SEC
SBC #$18
RTL



playSPCTH:
LDA $7e0163
cmp #$4e
BEQ playEuclid
cmp #$4f
BEQ playEuclid
bra endTH

playEuclid:
LDA $7e0163
BEQ endTH
LDA #$00
STA $7e0163
PHP
LDA $7e0160
JSL newTrack
PLP
LDA #$03
STA $002007
LDA #$FF
STA $002006
STA $7e1602
BRA endTH



securityCheckHarvestTH:
BCS $01
RTL
LDA #$3f
PHA
LDA $7e0163
BNE $02
PLA
RTL
cmp #$4e
BEQ $06
cmp #$4f
BEQ $02
PLA
RTL
PHP
LDA #$00
STA $7e0163
STA $7e0164
LDA $7e0160
JSL newTrack
PLP
LDA #$03
STA $002007
LDA #$FF
STA $002006
PLA
RTL


pianoCheck:
PHP
SEP #$20
LDA $002002
cmp #$53 
BNE pianoEnd
LDA $7e0160
cmp #$17
BNE pianoEnd
LDA $002000
AND #$10 
BEQ $05
PLP
JML $C4095E
PLP
JML $C40960
pianoEnd:
plp
LDA $20
BEQ $04
JML $C4095E
JML $C40960




org $600500 // loop table
// 01-Non-loop, 03-Loop
//  00  01  02  03  04  05  06  07  08  09  0A  0B  0C  0D  0E  0F
db $03,$03,$01,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03 // themes 00-0f - 00
db $03,$03,$03,$03,$03,$03,$03,$01,$03,$03,$03,$03,$03,$03,$03,$01 // themes 10-1f - 10
db $03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$01,$01,$03,$01 // themes 20-2f - 20
db $03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$01,$03 // themes 30-3f - 30
db $03,$03,$03,$01,$01,$01,$03,$01,$01,$03,$03,$03,$03,$03,$03,$03 // themes 40-4f - 40
db $03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03 // themes 50-5f - 50
db $03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03 // themes 60-6f - 60
db $03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03 // themes 70-7f - 70
db $03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03 // themes 80-8f - 80
db $03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03 // themes 90-9f - 90
db $03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03 // themes a0-af - A0
db $03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03 // themes b0-bf - B0
db $03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03 // themes c0-cf - C0
db $03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03 // themes d0-df - D0
db $03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03 // themes e0-ef - E0
db $03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03 // themes f0-ff - F0